using System.Collections;

namespace System
{
	/// <summary>
	/// Provides methods for creating, manipulating, searching, and sorting arrays,
	/// thereby serving as the base class for all arrays in the common language runtime.
	/// </summary>
	public class Array
	{
		/// <summary>
		/// Gets a 32-bit integer that represents the total number of elements in all the dimensions of the Array.
		/// </summary>
		public int Length {
			get {
				unsafe{/*
				return this.__length;
				*/
				return 0;
				}
			}
		}
		
		// WARNING: NEVER ADD OTHER CONSTRUCTORS!
		private Array(object dimensions, object values = null) {
			unsafe{/*
			this.__items = [];
			this.__dimensions = dimensions;
			
			this.__array_get = function() {
				for(var d=0, i=0, m=1; d<arguments.length; d++) {
					if(arguments[d] >= this.__dimensions[d])
						throw new System.IndexOutOfRangeException();
					
					i += arguments[d]*m;
					m *= this.__dimensions[d];
				}
				
				return this.__items[i];
			}
			
			this.__array_set = function(value) {
				for(var d=1, i=0, m=1; d<arguments.length; d++) {
					if(arguments[d] >= this.__dimensions[d])
						throw new System.IndexOutOfRangeException();
					
					i += arguments[d]*m;
					m *= this.__dimensions[d];
				}
				
				this.__items[i] = value;
			}
			
			this.__length = 0;
			for(var i in dimensions)
				this.__length += dimensions[i];
			
			if(values != null)
				for(var i=0; i<values.length; i++)
					this.__items[i] = values[i];
			*/}
		}
		
		/// <summary>
		/// Gets a 32-bit integer that represents the number of elements in the specified dimension of the Array.
		/// </summary>
		/// <param name="dimension">A zero-based dimension of the Array whose length needs to be determined.</param>
		/// <returns>A 32-bit integer that represents the number of elements in the specified dimension.</returns>
		public int GetLength(int dimension) {
			unsafe {/*
				if(dimension >= this.__dimensions.length)
					throw new System.IndexOutOfRangeException();
			
				return this.__dimensions[dimension];
			*/
			return 0;
			}
		}
		
		// TODO: Add missing methods and fields.
	}
}