namespace System
{
	/// <summary>
	/// Represents the debugging console of the browser.
	/// </summary>
	public static class Console
	{
		/// <summary>
		/// Print the structure of an object as a browsable tree.
		/// </summary>
		/// <param name="obj">The object to print.</param>
		public static void Display(object obj) {
			unsafe{/*
			console.dir(obj);
			*/}
		}
		
		/// <summary>
		/// Print some text to the browser's debug console.
		/// </summary>
		/// <param name="text">The text or the object to print.</param>
		public static void WriteLine(object text) {
			unsafe{/*
			console.log('%s', text);
			*/}
		}
		
		/// <summary>
		/// Read a line of text from the user.
		/// </summary>
		/// <param name="message">Message to print to the user.</param>
		/// <returns>The line the user inserted.</returns>
		public static string ReadLine(object message = null) {
			unsafe{/*
			return prompt(message);
			*/
			return "";
			}
		}
	}
}

