namespace System.Dom
{
	/// <summary>
	/// When an HTML document is loaded into a web browser, it becomes a document object.
	/// </summary>
	public class DocumentNode : Node
	{
		// TODO
		//document.adoptNode(node) 	Returns an adapded node from another document to this document.
		
		// TODO
		//document.anchors 	Returns a collection of all the anchors in the document
		
		// TODO
		//document.applets 	Returns a collection of all the applets in the document
		
		// TODO
		//document.baseURI 	Returns the absolute base URI of a document
		
		// TODO
		//document.body 	Returns the body element of the document

		/// <summary>
		/// Closes the output stream previously opened with <code>Document.Open()</code>.
		/// </summary>
		public void Close() {
			unsafe{/*
			this.close();
			*/}
		}
		
		// TODO
		//document.cookie 	Returns all name/value pairs of cookies in the document
		
		// TODO
		//document.createAttribute() 	Creates an attribute node
		
		// TODO
		//document.createComment() 	Creates a Comment node with the specified text
		
		// TODO
		//document.createDocumentFragment() 	Creates an empty DocumentFragment node
		
		// TODO
		//document.createElement() 	Creates an Element node
		
		// TODO
		//document.createTextNode() 	Creates a Text node
		
		// TODO
		//document.doctype 	Returns the Document Type Declaration associated with the document
		
		// TODO
		//document.documentElement 	Returns the Document Element of the document (the HTML element)
		
		// TODO
		//document.documentMode 	Returns the mode used by the browser to render the document
		
		// TODO
		//document.documentURI 	Sets or returns the location of the document
		
		// TODO
		//document.domain 	Returns the domain name of the server that loaded the document
		
		// TODO
		//document.domConfig 	Returns the configuration used when normalizeDocument() is invoked
		
		// TODO
		//document.forms 	Returns a collection of all the forms in the document
		
		// TODO
		//document.getElementById() 	Returns the element that has the ID attribute with the specified value
		
		// TODO
		//document.getElementsByName() 	Accesses all elements with a specified name
		
		// TODO
		//document.getElementsByTagName() 	Returns a NodeList containing all elements with the specified tagname
		
		// TODO
		//document.images 	Returns a collection of all the images in the document
		
		// TODO
		//document.implementation 	Returns the DOMImplementation object that handles this document
		
		// TODO
		//document.importNode() 	Imports a node from another document
		
		// TODO
		//document.inputEncoding 	Returns the encoding, character set, used for the document
		
		// TODO
		//document.lastModified 	Returns the date and time the document was last modified
		
		// TODO
		//document.links 	Returns a collection of all the links in the document
		
		// TODO
		//document.normalize() 	Removes empty Text nodes, and joins adjacent nodes
		
		// TODO
		//document.normalizeDocument() 	Removes empty Text nodes, and joins adjacent nodes

		/// <summary>
		/// Opens an HTML output stream to collect output from <code>Document.Write()</code>.
		/// </summary>
		public void Open() {
			unsafe{/*
			this.open();
			*/}
		}

		/// <summary>
		/// Returns the (loading) status of the document.
		/// <para>uninitialized: has not started loading yet</para>
		/// <para>loading: is loading</para>
		/// <para>interactive: has loaded enough and the user can interact with it</para>
		/// <para>complete: fully loaded</para>
		/// </summary>
		// TODO: Create an enum for this.
		public string ReadyState {
			get {
				unsafe {/*
				return this.readyState;
				*/
				return "";
				}
			}
		}

		/// <summary>
		/// Returns the URL of the document that loaded the current document.
		/// </summary>
		public string Referrer {
			get {
				unsafe {/*
				return this.referrer;
				*/
				return "";
				}
			}
		}

		/// <summary>
		/// Renames the specified node.
		/// </summary>
		/// <param name="node">The node object you want to rename.</param>
		/// <param name="namespaceURI">Namespace URI of the node, can be <code>null</code>.</param>
		/// <param name="nodename">The new nodename.</param>
		/// <returns>The renamed node.</returns>
		public Node RenameNode(Node node, string namespaceURI, string nodename) {
			unsafe{/*
			return this.renameNode(node, namespaceURI, nodename);
			*/
			return null;
			}
		}

		/// <summary>
		/// Sets or returns whether error-checking is enforced or not.
		/// </summary>
		public bool StrictErrorChecking {
			get {
				unsafe {/*
				return this.strictErrorChecking;
				*/
				return false;
				}
			}
			
			set {
				unsafe {/*
				this.strictErrorChecking = value;
				*/}
			}
		}
		
		/// <summary>
		/// Sets or returns the title of the document.
		/// </summary>
		public string Title {
			get {
				unsafe {/*
				return this.title;
				*/
				return "";
				}
			}
			
			set {
				unsafe {/*
				this.title = value;
				*/}
			}
		}

		/// <summary>
		/// Returns the full URL of the document.
		/// </summary>
		public string Url {
			get {
				unsafe {/*
				return this.URL;
				*/
				return "";
				}
			}
		}

		/// <summary>
		/// Writes HTML expressions or JavaScript code to a document.
		/// </summary>
		/// <param name="text">The expression or code to write.</param>
		public void Write(object text) {
			unsafe{/*
			this.write(text);
			*/}
		}
		
		/// <summary>
		/// Same as <code>Write()</code>, but adds a newline character after each statement.
		/// </summary>
		/// <param name="text">The expression or code to write.</param>
		public void WriteLine(object text = null) {
			unsafe{/*
			this.writeln(text ? text : '');
			*/}
		}
	}
	
	/// <summary>
	/// Represents the webpage that hosts the code.
	/// </summary>
	public static class Document
	{
		// TODO
		//document.adoptNode(node) 	Returns an adapded node from another document to this document.
		
		// TODO
		//document.anchors 	Returns a collection of all the anchors in the document
		
		// TODO
		//document.applets 	Returns a collection of all the applets in the document
		
		// TODO
		//document.baseURI 	Returns the absolute base URI of a document
		
		// TODO
		//document.body 	Returns the body element of the document
		
		/// <summary>
		/// Closes the output stream previously opened with <code>Document.Open()</code>.
		/// </summary>
		public static void Close() {
			unsafe{/*
			document.close();
			*/}
		}

		// TODO
		//document.cookie 	Returns all name/value pairs of cookies in the document
		
		// TODO
		//document.createAttribute() 	Creates an attribute node
		
		// TODO
		//document.createComment() 	Creates a Comment node with the specified text
		
		// TODO
		//document.createDocumentFragment() 	Creates an empty DocumentFragment node
		
		// TODO
		//document.createElement() 	Creates an Element node
		
		// TODO
		//document.createTextNode() 	Creates a Text node
		
		// TODO
		//document.doctype 	Returns the Document Type Declaration associated with the document
		
		// TODO
		//document.documentElement 	Returns the Document Element of the document (the HTML element)
		
		// TODO
		//document.documentMode 	Returns the mode used by the browser to render the document
		
		// TODO
		//document.documentURI 	Sets or returns the location of the document
		
		// TODO
		//document.domain 	Returns the domain name of the server that loaded the document
		
		// TODO
		//document.domConfig 	Returns the configuration used when normalizeDocument() is invoked
		
		// TODO
		//document.forms 	Returns a collection of all the forms in the document
		
		// TODO
		//document.getElementById() 	Returns the element that has the ID attribute with the specified value
		
		// TODO
		//document.getElementsByName() 	Accesses all elements with a specified name
		
		// TODO
		//document.getElementsByTagName() 	Returns a NodeList containing all elements with the specified tagname
		
		// TODO
		//document.images 	Returns a collection of all the images in the document
		
		// TODO
		//document.implementation 	Returns the DOMImplementation object that handles this document
		
		// TODO
		//document.importNode() 	Imports a node from another document
		
		// TODO
		//document.inputEncoding 	Returns the encoding, character set, used for the document
		
		// TODO
		//document.lastModified 	Returns the date and time the document was last modified
		
		// TODO
		//document.links 	Returns a collection of all the links in the document
		
		// TODO
		//document.normalize() 	Removes empty Text nodes, and joins adjacent nodes
		
		// TODO
		//document.normalizeDocument() 	Removes empty Text nodes, and joins adjacent nodes
		
		/// <summary>
		/// Opens an HTML output stream to collect output from <code>Document.Write()</code>.
		/// </summary>
		public static void Open() {
			unsafe{/*
			document.open();
			*/}
		}
		
		/// <summary>
		/// Returns the (loading) status of the document.
		/// <para>uninitialized: has not started loading yet</para>
		/// <para>loading: is loading</para>
		/// <para>interactive: has loaded enough and the user can interact with it</para>
		/// <para>complete: fully loaded</para>
		/// </summary>
		// TODO: Create an enum for this.
		public static string ReadyState {
			get {
				unsafe {/*
				return document.readyState;
				*/
				return "";
				}
			}
		}

		/// <summary>
		/// Returns the URL of the document that loaded the current document.
		/// </summary>
		public static string Referrer {
			get {
				unsafe {/*
				return document.referrer;
				*/
				return "";
				}
			}
		}
		
		/// <summary>
		/// Renames the specified node.
		/// </summary>
		/// <param name="node">The node object you want to rename.</param>
		/// <param name="namespaceURI">Namespace URI of the node, can be <code>null</code>.</param>
		/// <param name="nodename">The new nodename.</param>
		/// <returns>The renamed node.</returns>
		public static Node RenameNode(Node node, string namespaceURI, string nodename) {
			unsafe{/*
			return document.renameNode(node, namespaceURI, nodename);
			*/
			return null;
			}
		}
		
		/// <summary>
		/// Sets or returns whether error-checking is enforced or not.
		/// </summary>
		public static bool StrictErrorChecking {
			get {
				unsafe {/*
				return document.strictErrorChecking;
				*/
				return false;
				}
			}
			
			set {
				unsafe {/*
				document.strictErrorChecking = value;
				*/}
			}
		}
		/// <summary>
		/// Sets or returns the title of the document.
		/// </summary>
		public static string Title {
			get {
				unsafe {/*
				return document.title;
				*/
				return "";
				}
			}
			
			set {
				unsafe {/*
				document.title = value;
				*/}
			}
		}
		
		/// <summary>
		/// Returns the full URL of the document.
		/// </summary>
		public static string Url {
			get {
				unsafe {/*
				return document.URL;
				*/
				return "";
				}
			}
		}
		
		/// <summary>
		/// Writes HTML expressions or JavaScript code to a document.
		/// </summary>
		/// <param name="text">The expression or code to write.</param>
		public static void Write(object text) {
			unsafe{/*
			document.write(text);
			*/}
		}
		
		/// <summary>
		/// Same as <code>Write()</code>, but adds a newline character after each statement.
		/// </summary>
		/// <param name="text">The expression or code to write.</param>
		public static void WriteLine(object text = null) {
			unsafe{/*
			document.writeln(text ? text : '');
			*/}
		}
	}
}

