namespace System
{
	/// <summary>
	/// Provides constants and static methods for trigonometric, logarithmic, and other common mathematical functions.
	/// </summary>
	public static class Math
	{
		/// <summary>
		/// Returns Euler's number.
		/// </summary>
		public static double E {
			get{
				unsafe {/*
				return Math.E;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the natural logarithm of <code>2</code>.
		/// </summary>
		public static double LN2 {
			get{
				unsafe {/*
				return Math.LN2;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the natural logarithm of <code>10</code>.
		/// </summary>
		public static double LN10 {
			get{
				unsafe {/*
				return Math.LN10;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the base-2 logarithm of <code>E</code>.
		/// </summary>
		public static double LOG2E {
			get{
				unsafe {/*
				return Math.LOG2E;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the base-10 logarithm of <code>E</code>.
		/// </summary>
		public static double LOG10E {
			get{
				unsafe {/*
				return Math.LOG10E;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns <code>PI</code>.
		/// </summary>
		public static double PI {
			get{
				unsafe {/*
				return Math.PI;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the square root of <code>1/2</code>.
		/// </summary>
		public static double SQRT1_2 {
			get{
				unsafe {/*
				return Math.SQRT1_2;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the square root of <code>2</code>.
		/// </summary>
		public static double SQRT2 {
			get{
				unsafe {/*
				return Math.SQRT2;
				*/
				return 0;
				}
			}
		}
		
		/// <summary>
		/// Returns the absolute value of <code>x</code>.
		/// </summary>
		/// <param name="x">The value to get the absolute value of.</param>
		/// <returns>Absolute value of <code>x</code>.</returns>
		public static double Abs(double x) {
			unsafe{/*
			return Math.abs(x);
			*/
			return 0;
			}
		}
			
		/// <summary>
		/// Returns the arccosine of <code>x</code>, in radians.
		/// </summary>
		/// <param name="x">The value to get the arccosine of.</param>
		/// <returns>Arccosine of <code>x</code>.</returns>
		public static double Acos(double x) {
			unsafe{/*
			return Math.acos(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the arcsine of <code>x</code>, in radians.
		/// </summary>
		/// <param name="x">The value to get the arcsine of.</param>
		/// <returns>Arcsine of <code>x</code>.</returns>
		public static double Asin(double x) {
			unsafe{/*
			return Math.asin(x);
			*/
			return 0;
			}
		}
			
		/// <summary>
		/// Returns the arctangent of <code>x</code> as a numeric value between <code>-PI/2</code> and <code>+PI/2</code> radians.
		/// </summary>
		/// <param name="x">The value to get the arctangent of.</param>
		/// <returns>Arctangent of <code>x</code>.</returns>
		public static double Atan(double x) {
			unsafe{/*
			return Math.atan(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the arctangent of the quotient of its arguments.
		/// </summary>
		/// <param name="x">Coordinate <code>X</code>.</param>
		/// <param name="y">Coordinate <code>Y</code>.</param>
		/// <returns>Arctangent of the quotient of <code>(x, y)</code></returns>
		public static double Atan2(double x, double y) {
			unsafe{/*
			return Math.atan2(x, y);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns <code>x</code>, rounded upwards to the nearest integer.
		/// </summary>
		/// <param name="x">The value to get the ceiling of.</param>
		/// <returns>Ceiling of <code>x</code>.</returns>
		public static double Ceiling(double x) {
			unsafe{/*
			return Math.ceil(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the cosine of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the cosine of.</param>
		/// <returns>Cosine of <code>x</code>.</returns>
		public static double Cos(double x) {
			unsafe{/*
			return Math.cos(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the hyperbolic cosine of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the hyperbolic cosine of.</param>
		/// <returns>Hyperbolic cosine of <code>x</code>.</returns>
		public static double Cosh(double x) {
			unsafe{/*
			return (Math.exp(2*x) + 1) / (2 * Math.exp(x));
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the value of <code>E</code> to the power of <code>x</code>.
		/// </summary>
		/// <param name="x">The exponent.</param>
		/// <returns><code>E</code> to the power of <code>x</code>.</returns>
		public static double Exp(double x) {
			unsafe{/*
			return Math.exp(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns <code>x</code>, rounded downwards to the nearest integer.
		/// </summary>
		/// <param name="x">The value to get the ceiling of.</param>
		/// <returns>Ceiling of <code>x</code>.</returns>
		public static double Floor(double x) {
			unsafe{/*
			return Math.floor(x);
			*/
			return 0;
			}
		}
			
		/// <summary>
		/// Returns the natural logarithm (base <code>E</code>) of <code>x</code>.
		/// </summary>
		/// <param name="x">The value to get the natural logarithm of.</param>
		/// <returns>Natural logarithm of <code>x</code>.</returns>
		public static double Log(double x) {
			unsafe{/*
			return Math.log(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the common logarithm (base <code>10</code>) of <code>x</code>.
		/// </summary>
		/// <param name="x">The value to get the common logarithm of.</param>
		/// <returns>Common logarithm of <code>x</code>.</returns>
		public static double Log10(double x) {
			unsafe{/*
			return Math.log(x) / Math.LN10;
			*/
			return 0;
			}
		}
		
		// TODO
		//max(x,y,z,...,n) 	Returns the number with the highest value
		
		// TODO
		//min(x,y,z,...,n) 	Returns the number with the lowest value
		
		/// <summary>
		/// Returns the value of <code>x</code> to the power of <code>y</code>.
		/// </summary>
		/// <param name="x">The base.</param>
		/// <param name="y">The exponent.</param>
		/// <returns><code>x</code> to the power of <code>y</code>.</returns>
		public static double Pow(double x, double y) {
			unsafe{/*
			return Math.pow(x, y);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns a random number between <code>0</code> and <code>1</code>.
		/// </summary>
		/// <returns>A random number between <code>0</code> and <code>1</code>.</returns>
		public static double Random() {
			unsafe{/*
			return Math.random();
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Rounds <code>x</code> to the nearest integer.
		/// </summary>
		/// <param name="x">The value to get the rounded value of.</param>
		/// <returns><code>x</code> rounded to the nearest integer.</returns>
		public static double Round(double x) {
			unsafe{/*
			return Math.round(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the sine of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the sine of.</param>
		/// <returns>Sine of <code>x</code>.</returns>
		public static double Sin(double x) {
			unsafe{/*
			return Math.sin(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the hyperbolic sine of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the hyperbolic sine of.</param>
		/// <returns>Hyperbolic sine of <code>x</code>.</returns>
		public static double Sinh(double x) {
			unsafe{/*
			return (Math.exp(2*x) - 1) / (2 * Math.exp(x));
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the square root of <code>x</code>.
		/// </summary>
		/// <param name="x">The value to get the square root of.</param>
		/// <returns>Square root of <code>x</code>.</returns>
		public static double Sqrt(double x) {
			unsafe{/*
			return Math.sqrt(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the tangent of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the tangent of.</param>
		/// <returns>Tangent of <code>x</code>.</returns>
		public static double Tan(double x) {
			unsafe{/*
			return Math.tan(x);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the hyperbolic tangent of <code>x</code> (<code>x</code> is in radians).
		/// </summary>
		/// <param name="x">The value to get the hyperbolic tangent of.</param>
		/// <returns>Hyperbolic tangent of <code>x</code>.</returns>
		public static double Tanh(double x) {
			unsafe{/*
			return (Math.exp(2*x) + 1) / (Math.exp(2*x) - 1);
			*/
			return 0;
			}
		}
		
		/// <summary>
		/// Returns the integral part of <code>x</code>.
		/// </summary>
		/// <param name="x">Returns the integral part of a number.</param>
		/// <returns>Integral part of <code>x</code>.</returns>
		public static double Truncate(double x) {
			unsafe{/*
			return x - x%1;
			*/
			return 0;
			}
		}
	}
}