/*
EXPECTED OUTPUT:
--- DEFINING NEW ARRAY ---
Length: 3

Element 0: 1
Element 1: 3
Element 2: 5

--- DEFINING ARRAY WITH VALUES ---
Element 0: 10
Element 1: 20
Element 2: 30

--- DEFINING MULTIDIMENSIONAL ARRAY ---
0 ~ 0       0 ~ 1       0 ~ 2       0 ~ 3       0 ~ 4      
1 ~ 0       1 ~ 1       1 ~ 2       1 ~ 3       1 ~ 4      
2 ~ 0       2 ~ 1       2 ~ 2       2 ~ 3       2 ~ 4      
3 ~ 0       3 ~ 1       3 ~ 2       3 ~ 3       3 ~ 4      
4 ~ 0       4 ~ 1       4 ~ 2       4 ~ 3       4 ~ 4       

--- DEFINING ARRAY OF ARRAYS ---
0 ~ 0       0 ~ 1       0 ~ 2       0 ~ 3       0 ~ 4      
1 ~ 0       1 ~ 1       1 ~ 2       1 ~ 3       1 ~ 4      
2 ~ 0       2 ~ 1       2 ~ 2       2 ~ 3       2 ~ 4      
3 ~ 0       3 ~ 1       3 ~ 2       3 ~ 3       3 ~ 4      
4 ~ 0       4 ~ 1       4 ~ 2       4 ~ 3       4 ~ 4       
*/
using System;
using System.Dom;

namespace TestNamespace
{
	static class TestClass
	{
		public static void Main(string[] args)
		{
			Document.WriteLine("--- DEFINING NEW ARRAY ---");
			int[] array = new int[3];
			
			Document.WriteLine("Length: "+array.Length);
			
			Document.WriteLine();
			
			for(int i=0; i<array.Length; i++)
				array[i] = i*2;
				
			for(int i=0; i<array.Length; i++)
				array[i] += 1;
			
			for(int i=0; i<array.Length; i++)
				Document.WriteLine("Element "+i+": "+array[i]);
			
			Document.WriteLine();
			
			Document.WriteLine("--- DEFINING ARRAY WITH VALUES ---");
			
			array = new int[] {10, 20, 30};
			
			for(int i=0; i<array.Length; i++)
				Document.WriteLine("Element "+i+": "+array[i]);
			
			Document.WriteLine();
			
			Document.WriteLine("--- DEFINING MULTIDIMENSIONAL ARRAY ---");
			
			int[,] array2 = new int[5, 5];
			
			for(int x=0; x<array2.GetLength(0); x++) {
				for(int y=0; y<array2.GetLength(1); y++) {
					array2[x, y] = x+" ~ "+y;
				}
			}
			
			for(int x=0; x<array2.GetLength(0); x++) {
				for(int y=0; y<array2.GetLength(1); y++) {
					Document.Write(array2[x, y]+" &nbsp; &nbsp; &nbsp; ");
				}
				
				Document.WriteLine();
			}
			
			Document.WriteLine();
			
			// NOT SUPPORTED BY CURRENT VERSION OF THE COMPILER
			/*Document.WriteLine("--- DEFINING ARRAY OF ARRAYS ---");
			
			int[][] array3 = new int[5][5];
			
			for(int x=0; x<array3.length; x++) {
				for(int y=0; y<array3[x].length; y++) {
					array3[x][y] = x+" ~ "+y;
				}
			}
			
			for(int x=0; x<array3.length; x++) {
				for(int y=0; y<array3[x].length; y++) {
					Document.Write(array3[x][y]+" &nbsp; &nbsp; &nbsp; ");
				}
				
				Document.WriteLine();
			}*/
		}
	}
}