/*
EXPECTED OUTPUT:
Int: 10
String: hello
Int+String: 15, world
Float+String: 3.14, auto
Parameters: 1 2 3 4 5 
*/

using System;
using System.Dom;

namespace TestNamespace
{
	static class TestClass
	{
		public static void TestFunction(int integer)
		{
			Document.WriteLine("Int: "+integer);
		}
		
		public static void TestFunction(string text)
		{
			Document.WriteLine("String: "+text);
		}
		
		public static void TestFunction(int integer, string text)
		{
			Document.WriteLine("Int+String: "+integer+", "+text);
		}
	
		public static void TestFunction(float number, string text = "auto")
		{
			Document.WriteLine("Float+String: "+number+", "+text);
		}
	
		public static void ParamsFunction(params int[] parameters)
		{
			Document.Write("Parameters: ");
			
			for(int i=0; i<parameters.Length; i++)
			{
				Document.Write(parameters[i]+" ");
			}
			
			Document.WriteLine();
		}
	
		public static void Main(string[] args)
		{
			TestFunction(10);
			TestFunction("hello");
			TestFunction(15, "world");
			TestFunction(3.14f);
			
			ParamsFunction(1, 2, 3, 4, 5);
		}
	}
}