/*
EXPECTED OUTPUT:
true
false
[object Object]
null
Human, Name: John
Name: Isaak, friend
Human, Name: Isaak
Canine
*/
using System;
using System.Dom;

namespace TestNamespace
{
	public class Animal
	{
		public string Race;
		
		public Animal(string race = null)
		{
			Race = (race == null) ? "Unknown" : race;
		}
		
		public void PrintRace() {
			Document.WriteLine(Race);
		}
	}

	public class Person : Animal
	{
		public string Name;
		
		public Person(string name = null) : base("Human")
		{
			Name = (name == null) ? "Unnamed" : name;
		}
		
		public void PrintName() {
			Document.WriteLine(Race+", Name: "+Name);
		}
	}
	
	public class Friend : Person
	{
		public bool Bestfriend;
		
		public Friend(string name = null, bool bestfriend = false) : base(name)
		{
			Bestfriend = bestfriend;
		}
		
		public void PrintInfo() {
			Document.WriteLine("Name: "+Name+", "+(Bestfriend ? "bestfriend" : "friend"));
		}
	}
	
	static class TestClass
	{
		public static void Main(string[] args)
		{
			Friend myFriend = new Friend("Isaak");
			Animal myDog = new Animal("Canine");
			Person myBrother = new Person("John");
			
			Document.WriteLine(myFriend is Animal);	// true
			Document.WriteLine(myDog is Person);	// false
			
			Document.WriteLine(myFriend as Animal);	// [object Object]
			Document.WriteLine(myDog as Person);	// null
			
			myBrother.PrintName();	// Human, Name: John
			myFriend.PrintInfo();	// Name: Isaak, friend
			myFriend.PrintName();	// Human, Name: Isaak
			myDog.PrintRace();		// Canine
		}
	}
}

