/*
INPUT:
2

EXPECTED OUTPUT:
--- STATEMENTS ---
INPUT: 2

IF-ELSE: 2 is even.

FOR:
Line 0
Line 1

WHILE:
Line 1
Line 0

DO-WHILE:
Line 2
Line 1
Line 0

SWITCH-CASE: Two, Three or Four.

TRY-CATCH-FINALLY:
Try...
Catch...
Finally...

--- OPERATORS ---
UNARY:
false
-11
-6
6
6
8
8
6

BINARY:
4
14
false
true
12
true
true
true
false
true
false
false
16
4
60
1
4
640
0

TERNARY:
6

--- PRECENDENCE ---
20
84
*/

using System;
using System.Dom;

namespace TestNamespace
{
	static class TestClass
	{
		public static void Main(string[] args)
		{
			Document.WriteLine("--- STATEMENTS ---");
		
			int number = int.Parse(Console.ReadLine("Input a number (between 2 and 20):"));
			Document.WriteLine("INPUT: "+number);
			Document.WriteLine();
			
			
			Document.Write("IF-ELSE: ");
			if(number%2 == 0) {
				Document.WriteLine(number+" is even.");
			} else {
				Document.WriteLine(number+" is odd.");
			}
			Document.WriteLine();
			
			
			Document.WriteLine("FOR:");
			for(int i=0; i<number; i++) {
				Document.WriteLine("Line "+i);
			}
			Document.WriteLine();
			
			
			Document.WriteLine("WHILE:");
			int j = number;
			while(j-- > 0) {
				Document.WriteLine("Line "+j);
			}
			Document.WriteLine();
			
			
			Document.WriteLine("DO-WHILE:");
			int k = number;
			do {
				Document.WriteLine("Line "+k);
			} while(k-- > 0);
			Document.WriteLine();
			
			
			Document.Write("SWITCH-CASE: ");
			switch(number) {
				case 2:
				case 3:
				case 4:
					Document.WriteLine("Two, Three or Four.");
					break;
				
				case 5:
				case 6:
				case 7:
					Document.WriteLine("Five, Six or Seven.");
					break;
					
				default:
					Document.WriteLine("Not between Two and Seven.");
					break;
			}
			Document.WriteLine();
			
			
			Document.WriteLine("TRY-CATCH-FINALLY:");
			try {
				Document.WriteLine("Try...");
				throw new Exception();
				Document.WriteLine("Should not print!");
			} catch(Exception e) {
				Document.WriteLine("Catch...");
			} finally {
				Document.WriteLine("Finally...");
			}
			Document.WriteLine();
			
			
			
			
			
			Document.WriteLine("--- OPERATORS ---");
			
			int a = 6;
			
			Document.WriteLine("UNARY:");
			Document.WriteLine( !true );	// false
			Document.WriteLine( ~ 10 );		// -11
			Document.WriteLine( -a );		// -6
			Document.WriteLine( +a );		// 6
			Document.WriteLine( a++ );		// 6
			Document.WriteLine( ++a );		// 8
			Document.WriteLine( a-- );		// 8
			Document.WriteLine( --a );		// 6
			Document.WriteLine();
			
			Document.WriteLine("BINARY:");
			Document.WriteLine( 10 & 6 );			// 4
			Document.WriteLine( 10 | 6 );			// 14
			Document.WriteLine( true && false );	// false
			Document.WriteLine( true || false );	// true
			Document.WriteLine( 10 ^ 6 );			// 12
			Document.WriteLine( true ^ false );		// true
			Document.WriteLine( 10 > 6 );			// true
			Document.WriteLine( 10 >= 6 );			// true
			Document.WriteLine( 10 == 6 );			// false
			Document.WriteLine( 10 != 6 );			// true
			Document.WriteLine( 10 < 6 );			// false
			Document.WriteLine( 10 <= 6 );			// false
			Document.WriteLine( 10 + 6 );			// 16
			Document.WriteLine( 10 - 6 );			// 4
			Document.WriteLine( 10 * 6 );			// 60
			Document.WriteLine( 10 / 6 );			// 1
			Document.WriteLine( 10 % 6 );			// 4
			Document.WriteLine( 10 << 6 );			// 640
			Document.WriteLine( 10 >> 6 );			// 0
			Document.WriteLine();
			
			Document.WriteLine("TERNARY:");
			Document.WriteLine( false ? 10 : 6 );	// 6
			Document.WriteLine();
			
			
			
			
			
			Document.WriteLine("--- PRECENDENCE ---");
			Document.WriteLine(  10 + 2  *  3 + 4  );	// 20
			Document.WriteLine( (10 + 2) * (3 + 4) );	// 84
			Document.WriteLine();
		}
	}
}